> ## Documentation Index
> Fetch the complete documentation index at: https://docs.gmicloud.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# GPT-5.4 Pro

> GPT-5.4 Pro is OpenAI's most advanced model, building on GPT-5.4's unified architecture with enhanced reasoning capabilities for complex, high-stakes tasks.

**Model ID**

```bash theme={null}
openai/gpt-5.4-pro
```

## API Usage

You can interact with the OpenAI GPT-5.4-pro model through various programming languages and methods. Below are examples showing how to use the model's API.

## API Examples

Generate a model response using the chat endpoint of OpenAI GPT-5.4-pro.

### Create a model response

OpenAI's most advanced interface for generating model responses. Supports text and image inputs, and text outputs. Create stateful interactions with the model, using the output of previous responses as input. Extend the model's capabilities with built-in tools for file search, web search, computer use, and more. Allow the model access to external systems and data using function calling.

#### Default

```bash theme={null}
curl https://api.gmi-serving.com/v1/responses \
  -H "Content-Type: application/json" \
  -H "Authorization: Bearer $GMI_API_KEY" \
  -d '{
    "model": "openai/gpt-5.4-pro",
    "input": "Tell me a three sentence bedtime story about a unicorn."
  }'
```

#### Streaming

```bash theme={null}
curl https://api.gmi-serving.com/v1/responses \
  -H "Content-Type: application/json" \
  -H "Authorization: Bearer $GMI_API_KEY" \
  -d '{
    "model": "openai/gpt-5.4-pro",
    "instructions": "You are a helpful assistant.",
    "input": "Hello!",
    "stream": true
  }'
```

#### Reasoning

```bash theme={null}
curl https://api.gmi-serving.com/v1/responses \
  -H "Content-Type: application/json" \
  -H "Authorization: Bearer $GMI_API_KEY" \
  -d '{
    "model": "openai/gpt-5.4-pro",
    "input": "How much wood would a woodchuck chuck?",
    "reasoning": {
      "effort": "low"
    }
  }'
```

#### Functions

```bash theme={null}
curl https://api.gmi-serving.com/v1/responses \
  -H "Content-Type: application/json" \
  -H "Authorization: Bearer $GMI_API_KEY" \
  -d '{
    "model": "openai/gpt-5.4-pro",
    "input": "What is the weather like in Boston today?",
    "tools": [
      {
        "type": "function",
        "name": "get_current_weather",
        "description": "Get the current weather in a given location",
        "parameters": {
          "type": "object",
          "properties": {
            "location": {
              "type": "string",
              "description": "The city and state, e.g. San Francisco, CA"
            },
            "unit": {
              "type": "string",
              "description": "Temperature unit",
              "enum": ["celsius", "fahrenheit"]
            }
          },
          "required": ["location", "unit"]
        }
      }
    ],
    "tool_choice": "auto"
  }'
```

#### Image Input

```bash theme={null}
curl https://api.gmi-serving.com/v1/responses \
  -H "Content-Type: application/json" \
  -H "Authorization: Bearer $GMI_API_KEY" \
  -d '{
    "model": "openai/gpt-5.4-pro",
    "input": [
      {
        "role": "user",
        "content": [
          {"type": "input_text", "text": "what is in this image?"},
          {
            "type": "input_image",
            "image_url": "https://qianwen-res.oss-cn-beijing.aliyuncs.com/Qwen-VL/assets/demo.jpeg"
          }
        ]
      }
    ]
  }'
```

#### File Input

```bash theme={null}
curl https://api.gmi-serving.com/v1/responses \
  -H "Content-Type: application/json" \
  -H "Authorization: Bearer $GMI_API_KEY" \
  -d '{
    "model": "openai/gpt-5.4-pro",
    "input": [
      {
        "role": "user",
        "content": [
          {"type": "input_text", "text": "what is in this file?"},
          {
            "type": "input_file",
            "file_url": "https://www.berkshirehathaway.com/letters/2024ltr.pdf"
          }
        ]
      }
    ]
  }'
```

#### Web search

```bash theme={null}
curl https://api.gmi-serving.com/v1/responses \
  -H "Content-Type: application/json" \
  -H "Authorization: Bearer $GMI_API_KEY" \
  -d '{
    "model": "openai/gpt-5.4-pro",
    "tools": [{ "type": "web_search_preview" }],
    "input": "What was a positive news story from today?"
  }'
```
